100 TURBO_taskn 'DirSizeT'
102 TURBO_objfil 'ram1_DirSizeT_task'
104 TURBO_repfil 'ram1_report_txt'
106 TURBO_windo 0
108 TURBO_objdat 4
110 :
112 rem     DirSize in harness
114 rem V0.01, pjw, 2018 Nov 18, Uses Qmenu and tk2 or SMSQ/E
116 :
118 ch = fopen(#0; "con_400x200a20x20")
120 cls#ch
122 border#ch; 1,4
124 outln: rem #ch; 400, 200, 20, 20
126 oldd$ = datad$:                  rem Keep original DATAD$
128 dird$ = oldd$: subd$ = ''
130 :
132 rep lp
134  data_use dird$ & subd$:          rem DIR_SELECT$ uses DATAD$ for its default
136  dird$ = dir_select$('Dir Size')
138  data_use oldd$
140  if len(dird$) = 0: exit lp
142  :
144  if len(dird$) > 5 then
146   subd$ = dird$(6 to): dird$ = dird$(1 to 5)
148  else
150   subd$ = ''
152  endif
154  :
156  rem    Init GLOBal counters
158  fil = 0
160  drc = 0
162  siz = 0
164  :
166  tt = date
168  er = CountDir(dird$, subd$)
170  tt = date - tt
172  ink#ch; 7
174  print#ch; 'Stats of'! dird$; subd$\\
176  ink#ch; 4
178  print#ch; 'Size  =', cdec$(siz, 14, 0)! 'b'
180  print#ch; 'Dirs  =', drc
182  print#ch; 'Files =', fil
184  print#ch; 'Time  =', tt; 's'\\
186  pause#ch
188 endrep lp
190 quit
192 :
194 :
196 rem + ------------------------------------------------------------------------ +
198 rem |<                            Count Directory                             >|
200 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
202 rem |                                Tree size                                 |
204 rem |                                                                          |
206 rem | Go through a directory sub tree recursively counting all files and       |
208 rem | directories encountered and add up their total size (including headers!) |
210 rem |                                                                          |
212 rem | GLOBal drc, fil, siz                                                     |
214 rem + ------------------------------------------------------------------------ +
216 rem | V0.01, pjw, 2014 May 18                                                  |
218 rem | V0.04, pjw, 2018 Nov 18, simplified and generalised version              |
220 rem | V0.04, pjw, 2025 Mar 09, GET#cd\pos+14 -> SET_POSITION pos+14:GET$(#cd)  |
222 rem + ------------------------------------------------------------------------ +
224 :
226 DEFine FuNction CountDir(fdv$, dir$)
228 LOCal cd, lp, er, fl, ps, l, ty%, nm$(36)
230 :
232 cd = FOP_DIR(fdv$ & dir$): IF cd < 0: RETurn cd
234 ps = 0: er = 0: fl = FLEN(#cd)
236 REPeat lp
238  IF ps >= fl: EXIT lp
240  SET_POSITION#cd; ps + 14: nm$ = GET$(#cd): rem Turbo doesnt get GET!
242  IF LEN(nm$) > 0 THEN
244   BGET#cd\ ps + 5, ty%
246   IF ty% = 255 THEN
248    drc = drc + 1
250    er = CountDir(fdv$, nm$): IF er < 0: EXIT lp
252   ELSE
254    lget#cd\ ps + 0, l: siz = siz + l
256    fil = fil + 1
258   END IF
260  END IF
262  ps = ps + 64
264 END REPeat lp
266 CLOSE#cd
268 RETurn er
270 END DEFine CountDir
272 :
274 :
